## mingw-w64-python-lief-0.13.2-2.src.tar.zst

=== doc/CMakeLists.txt ===
find_package(Doxygen)
find_package(Sphinx)

if(NOT DOXYGEN_FOUND)
  message(STATUS "Doc disabled: doxygen not found")
elseif(NOT SPHINX_FOUND)
  message(FATAL "Doc disabled: sphinx-build not found")
elseif(${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
  message(STATUS "You have to build the doc in another directory !")
else()
  message(STATUS "Sphinx: ${SPHINX_EXECUTABLE}")
  add_custom_target(lief-doxygen
      COMMAND
        ${CMAKE_COMMAND} -E env
          "LIEF_VERSION=${LIEF_VERSION_MAJOR}.${LIEF_VERSION_MINOR}.${LIEF_VERSION_PATCH}-${LIEF_COMMIT_HASH}"
          "LIEF_INPUT=${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include/LIEF ${CMAKE_SOURCE_DIR}/api/c/include ${CMAKE_SOURCE_DIR}/doc/doxygen/"
          "LIEF_EXCLUDE=${CMAKE_BINARY_DIR}/include/LIEF/third-party"
          "LIEF_INCLUDE_PATH=${CMAKE_BINARY_DIR}/include ${CMAKE_SOURCE_DIR}/include"
          "LIEF_DOXYGEN_WARN_FILE=${CMAKE_BINARY_DIR}/doxygen-warn.log"
        ${DOXYGEN_EXECUTABLE} ${CMAKE_SOURCE_DIR}/doc/doxygen/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating Doxygen documentation" VERBATIM)

  add_custom_target(lief-sphinx
      COMMAND ${CMAKE_COMMAND} -E env
        "PYTHONPATH=${CMAKE_SOURCE_DIR}:${CMAKE_BINARY_DIR}/../:${CMAKE_BINARY_DIR}/api/python:$ENV{PYTHONPATH}"
        "LIEF_DOXYGEN_XML=${CMAKE_CURRENT_BINARY_DIR}/doxygen/xml/"
        ${SPHINX_EXECUTABLE} -a -E -j4 -w ${CMAKE_BINARY_DIR}/sphinx-warn.log ${CMAKE_SOURCE_DIR}/doc/sphinx sphinx-doc
        DEPENDS pyLIEF lief-doxygen
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating Sphinx Documentation" VERBATIM)

  add_custom_target(lief-doc ALL
      DEPENDS lief-sphinx lief-doxygen
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating documentation with Doxygen and Sphinx" VERBATIM)

  add_custom_target(lief-quick-sphinx
      COMMAND ${CMAKE_COMMAND} -E env
        "PYTHONPATH=${CMAKE_SOURCE_DIR}:${CMAKE_BINARY_DIR}/../:${CMAKE_BINARY_DIR}/api/python:$ENV{PYTHONPATH}"
        "LIEF_DOXYGEN_XML=${CMAKE_CURRENT_BINARY_DIR}/doxygen/xml/"
        "FORCE_RTD_THEME=0"
        ${SPHINX_EXECUTABLE} -j4 -w ${CMAKE_BINARY_DIR}/sphinx-warn.log ${CMAKE_SOURCE_DIR}/doc/sphinx sphinx-doc
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating Sphinx documentation quickly" VERBATIM)

    install(
      DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html/
      DESTINATION
      share/LIEF/doc/doxygen
      COMPONENT doc)

    install(
      DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/sphinx-doc/
      DESTINATION
      share/LIEF/doc/sphinx
      COMPONENT doc)
endif()

=== profiling/CMakeLists.txt ===
set(PROFILING_FLAGS
    -fno-builtin-malloc -fno-builtin-calloc -fno-builtin-realloc
    -fno-builtin-free -fno-omit-frame-pointer -g)
target_compile_options(LIB_LIEF PUBLIC ${PROFILING_FLAGS})

add_executable(elf_profiler elf_profiler.cpp)

set_target_properties(elf_profiler
                      PROPERTIES POSITION_INDEPENDENT_CODE ON
                                 CXX_STANDARD              17
                                 CXX_STANDARD_REQUIRED     ON)

target_compile_options(elf_profiler PUBLIC ${PROFILING_FLAGS})
target_link_libraries(elf_profiler PRIVATE LIB_LIEF)

add_executable(macho_profiler macho_profiler.cpp)
target_compile_options(macho_profiler PUBLIC ${PROFILING_FLAGS})
target_link_libraries(macho_profiler PRIVATE LIB_LIEF)

set_target_properties(macho_profiler
                      PROPERTIES POSITION_INDEPENDENT_CODE ON
                                 CXX_STANDARD              17
                                 CXX_STANDARD_REQUIRED     ON)

add_executable(pe_profilier pe_profilier.cpp)
target_compile_options(pe_profilier PUBLIC ${PROFILING_FLAGS})
target_link_libraries(pe_profilier PRIVATE LIB_LIEF)

set_target_properties(pe_profilier
                      PROPERTIES POSITION_INDEPENDENT_CODE ON
                                 CXX_STANDARD              17
                                 CXX_STANDARD_REQUIRED     ON)

=== src/ART/CMakeLists.txt ===
set(LIEF_ART_SRC
  ${CMAKE_CURRENT_LIST_DIR}/Parser.cpp
  ${CMAKE_CURRENT_LIST_DIR}/Parser.tcc
  ${CMAKE_CURRENT_LIST_DIR}/File.cpp
  ${CMAKE_CURRENT_LIST_DIR}/EnumToString.cpp
  ${CMAKE_CURRENT_LIST_DIR}/Header.cpp
  ${CMAKE_CURRENT_LIST_DIR}/Header.tcc
  ${CMAKE_CURRENT_LIST_DIR}/utils.cpp
  ${CMAKE_CURRENT_LIST_DIR}/Structures.cpp
  ${CMAKE_CURRENT_LIST_DIR}/hash.cpp
)

set(LIEF_ART_INC_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/File.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/Header.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/Parser.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/types.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/utils.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/EnumToString.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/java_structures.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/hash.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/enums.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/Structures.hpp"

)

# JSON Public API: Always present
list(APPEND LIEF_ART_SRC       "${CMAKE_CURRENT_LIST_DIR}/json_api.cpp")
list(APPEND LIEF_ART_INC_FILES "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/ART/json.hpp")

# JSON Impl
if (LIEF_ENABLE_JSON)
  list(APPEND LIEF_ART_SRC       "${CMAKE_CURRENT_LIST_DIR}/json.cpp")
  list(APPEND LIEF_ART_INC_FILES "${CMAKE_CURRENT_LIST_DIR}/json_internal.hpp")
endif()

source_group("Source Files\\ART" FILES ${LIEF_ART_SRC})
source_group("Header Files\\ART" FILES ${LIEF_ART_INC_FILES})

if (LIEF_ART)
  target_sources(LIB_LIEF PRIVATE
    ${LIEF_ART_SRC}
    ${LIEF_ART_INC_FILES}
  )
endif()

=== src/MachO/CMakeLists.txt ===
set(LIEF_MACHO_SRC
  "${CMAKE_CURRENT_LIST_DIR}/Binary.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Binary.tcc"
  "${CMAKE_CURRENT_LIST_DIR}/BinaryParser.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/BinaryParser.tcc"
  "${CMAKE_CURRENT_LIST_DIR}/BindingInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/BuildVersion.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Builder.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Builder.tcc"
  "${CMAKE_CURRENT_LIST_DIR}/ChainedBindingInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ChainedBindingInfoList.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ChainedFixup.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/CodeSignature.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/CodeSignatureDir.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Convert.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DataCodeEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DataInCode.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DyldBindingInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DyldChainedFixups.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DyldEnvironment.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DyldExportsTrie.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DyldInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DylibCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DylinkerCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DynamicSymbolCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/EncryptionInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/EnumToString.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ExportInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/FatBinary.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/FilesetCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/FunctionStarts.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Header.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/LinkEdit.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/LinkerOptHint.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/LoadCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/MainCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Parser.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ParserConfig.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/RPathCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Relocation.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/RelocationDyld.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/RelocationFixup.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/RelocationObject.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Section.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/SegmentCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/SegmentSplitInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/SourceVersion.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/SubFramework.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Symbol.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/SymbolCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ThreadCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/TrieNode.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/TwoLevelHints.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/UUIDCommand.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/VersionMin.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/exports_trie.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/hash.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/utils.cpp"
)

set(LIEF_MACHO_INCLUDE_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Binary.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/BinaryParser.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/BindingInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/BuildVersion.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Builder.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/ChainedBindingInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/CodeSignature.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/CodeSignatureDir.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DataCodeEntry.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DataInCode.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DyldBindingInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DyldChainedFixups.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DyldEnvironment.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DyldExportsTrie.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DyldInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DylibCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/DylinkerCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/EncryptionInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/EnumToString.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/ExportInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/FatBinary.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/FunctionStarts.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Header.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/LinkEdit.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/LinkerOptHint.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/LoadCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/MainCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Parser.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/ParserConfig.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/RPathCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Relocation.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/RelocationDyld.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/RelocationFixup.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/RelocationObject.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Section.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/SegmentCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/SegmentSplitInfo.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/SourceVersion.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/SubFramework.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/Symbol.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/SymbolCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/ThreadCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/TwoLevelHints.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/UUIDCommand.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/VersionMin.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/enums.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/hash.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/type_traits.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/utils.hpp"

  "${CMAKE_CURRENT_LIST_DIR}/TrieNode.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/ChainedFixup.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/exports_trie.hpp"
)

# JSON Public API: Always present
list(APPEND LIEF_MACHO_SRC       "${CMAKE_CURRENT_LIST_DIR}/json_api.cpp")
list(APPEND LIEF_MACHO_INC_FILES "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/MachO/json.hpp")

# JSON Impl
if (LIEF_ENABLE_JSON)
  list(APPEND LIEF_MACHO_SRC       "${CMAKE_CURRENT_LIST_DIR}/json.cpp")
  list(APPEND LIEF_MACHO_INC_FILES "${CMAKE_CURRENT_LIST_DIR}/json_internal.hpp")
endif()

source_group("Header Files\\MachO" FILES ${LIEF_MACHO_INCLUDE_FILES})
source_group("Source Files\\MachO" FILES ${LIEF_MACHO_SRC})

if (LIEF_MACHO)
  target_sources(LIB_LIEF PRIVATE ${LIEF_MACHO_SRC} ${LIEF_MACHO_INCLUDE_FILES})
endif()

=== api/c/PE/CMakeLists.txt ===
include_directories(
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF"
  "${CMAKE_CURRENT_SOURCE_DIR}/include"
)
set(LIEF_API_C_PE_SRC
  "${CMAKE_CURRENT_LIST_DIR}/Binary.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DosHeader.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Header.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/OptionalHeader.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Section.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/DataDirectory.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/EnumToString.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/Import.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ImportEntry.cpp"
)


set(LIEF_API_C_PE_INCLUDE_FILES_CPP
  "${CMAKE_CURRENT_LIST_DIR}/Binary.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/DataDirectory.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/DosHeader.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/Header.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/OptionalHeader.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/Section.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/Import.hpp"
  "${CMAKE_CURRENT_LIST_DIR}/ImportEntry.hpp"
)

set(LIEF_API_C_PE_INCLUDE_FILES_C
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/enums.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/Binary.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/DataDirectory.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/DosHeader.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/EnumToString.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/Header.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/OptionalHeader.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/Section.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/Import.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/api/c/include/LIEF/PE/ImportEntry.h"
)


set(LIEF_C_PE_INC "${LIEF_API_C_PE_INCLUDE_FILES_C}" "${LIEF_API_C_PE_INCLUDE_FILES_CPP}")

source_group("Source Files\\C API\\PE" FILES ${LIEF_API_C_PE_SRC})
source_group("Header Files\\C API\\PE" FILES ${LIEF_C_PE_INC})

target_sources(LIB_LIEF PRIVATE "${LIEF_API_C_PE_SRC}" "${LIEF_C_PE_INC}")

=== api/python/src/PE/CMakeLists.txt ===
set(LIEF_PYTHON_PE_SRC
  "${CMAKE_CURRENT_LIST_DIR}/pyUtils.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/objects/pyResourceNode.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyResourceData.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyResourceDirectory.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceIcon.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceVersion.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceVarFileInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceFixedFileInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceStringFileInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyLangCodeItem.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceDialog.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceDialogItem.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceStringTable.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/resources/pyResourceAccelerator.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/objects/pyCodeIntegrity.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyDataDirectory.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyDosHeader.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyRichHeader.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyRichEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyBuilder.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyOptionalHeader.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyRelocationEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyBinary.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyResourcesManager.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyHeader.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyDebug.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyCodeView.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyCodeViewPDB.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyPogo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyPogoEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pySection.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyExport.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyImport.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyExportEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyRelocation.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyParser.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyImportEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyDelayImport.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyDelayImportEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pySymbol.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/objects/pyTLS.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyEnums.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyPE.cpp"
)

set(LIEF_PYTHON_PE_HDR
  "${CMAKE_CURRENT_LIST_DIR}/pyPE.hpp")

source_group("Source Files\\PE" FILES ${LIEF_PYTHON_PE_SRC})
source_group("Header Files\\PE" FILES ${LIEF_PYTHON_PE_HDR})

target_include_directories(pyLIEF PUBLIC "${CMAKE_CURRENT_LIST_DIR}")
target_sources(pyLIEF PRIVATE "${LIEF_PYTHON_PE_SRC}" "${LIEF_PYTHON_PE_HDR}")


include("${CMAKE_CURRENT_LIST_DIR}/objects/LoadConfigurations/CMakeLists.txt")
include("${CMAKE_CURRENT_LIST_DIR}/objects/signature/CMakeLists.txt")

=== src/PE/signature/attributes/CMakeLists.txt ===
set(LIEF_PE_SIGNATURE_ATTRIBUTES_SRC
  "${CMAKE_CURRENT_LIST_DIR}/GenericType.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/ContentType.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/SpcSpOpusInfo.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/MsCounterSign.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/MsSpcNestedSignature.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/MsSpcStatementType.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/PKCS9AtSequenceNumber.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/PKCS9CounterSignature.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/PKCS9MessageDigest.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/PKCS9SigningTime.cpp"
)

set(LIEF_PE_SIGNATURE_ATTRIBUTES_INCLUDES
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/GenericType.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/ContentType.hpp"

  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/SpcSpOpusInfo.hpp"

  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/MsCounterSign.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/MsSpcNestedSignature.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/MsSpcStatementType.hpp"

  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/PKCS9AtSequenceNumber.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/PKCS9CounterSignature.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/PKCS9MessageDigest.hpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/LIEF/PE/signature/attributes/PKCS9SigningTime.hpp"
)

source_group("Header Files\\PE\\signature\\attributes" FILES ${LIEF_PE_SIGNATURE_ATTRIBUTES_SRC})
source_group("Header Files\\PE\\signature\\attributes" FILES ${LIEF_PE_SIGNATURE_ATTRIBUTES_INCLUDES})

if (LIEF_PE)
  target_sources(LIB_LIEF PRIVATE
    ${LIEF_PE_SIGNATURE_ATTRIBUTES_SRC}
    ${LIEF_PE_SIGNATURE_ATTRIBUTES_INCLUDES}
  )
endif()

=== api/python/src/ELF/objects/NoteDetails/core/CMakeLists.txt ===
set(LIEF_PYTHON_ELF_NOTE_DETAILS_CORE
  "${CMAKE_CURRENT_LIST_DIR}/pyCorePrPsInfo.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyCoreFile.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyCoreFileEntry.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyCorePrStatus.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyCoreAuxv.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyCoreSigInfo.cpp"
)
target_sources(pyLIEF PRIVATE "${LIEF_PYTHON_ELF_NOTE_DETAILS_CORE}")

=== api/python/src/PE/objects/signature/attributes/CMakeLists.txt ===
set(LIEF_PYTHON_PE_SIG_ATTR_SRC
  "${CMAKE_CURRENT_LIST_DIR}/pyMsCounterSign.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyContentType.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyGenericType.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pySpcSpOpusInfo.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/pyMsSpcStatementType.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyMsSpcNestedSignature.cpp"

  "${CMAKE_CURRENT_LIST_DIR}/pyPKCS9SigningTime.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyPKCS9MessageDigest.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyPKCS9AtSequenceNumber.cpp"
  "${CMAKE_CURRENT_LIST_DIR}/pyPKCS9CounterSignature.cpp"
)

source_group("Header Files\\PE\\signature\\attributes" FILES ${LIEF_PYTHON_PE_SIG_ATTR_SRC})

target_include_directories(pyLIEF PUBLIC "${CMAKE_CURRENT_LIST_DIR}")
target_sources(pyLIEF PRIVATE ${LIEF_PYTHON_PE_SIG_ATTR_SRC})

=== PKGBUILD ===
# Maintainer: Marcelo Duarte https://github.com/marcelotduarte

_realname=lief
pkgbase=mingw-w64-python-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-python-${_realname}
pkgdesc="LIEF - Library to Instrument Executable Formats (mingw-w64)"
pkgver=0.13.2
pkgrel=2
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url="https://github.com/lief-project/LIEF/"
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-python")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-ccache"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-python-setuptools"
             "${MINGW_PACKAGE_PREFIX}-python-tomli")
options=('staticlibs' '!strip' '!debug')
source=(lief-${pkgver}.tar.gz::https://github.com/lief-project/LIEF/archive/refs/tags/${pkgver}.tar.gz
        0001-fix-exported-API-pymodule.patch)
sha256sums=('c68ef94ee613c6557faccc135bdaba4322c2e044be2b806ceea1de763cc099cf'
            '5d59f6a2e547f62ccbb00b469ab4316925576c562aee3be2a293beca6975c466')

prepare() {
  cd "${srcdir}/LIEF-${pkgver}"
  patch -p1 -i "${srcdir}/0001-fix-exported-API-pymodule.patch"

  (cd api/python && python setup.py egg_info)
}

build() {
  cd "${srcdir}/LIEF-${pkgver}"
  [[ -d build-${MSYSTEM} ]] && rm -rf build-${MSYSTEM}
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX" \
  ${MINGW_PREFIX}/bin/cmake.exe -LAH \
    -G"Ninja" \
    -DCMAKE_BUILD_TYPE="Release" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DLIEF_PYTHON_API=ON \
    -DLIEF_DISABLE_FROZEN=OFF \
    -DCMAKE_SKIP_RPATH=ON \
    -DLIEF_INSTALL_PYTHON=ON \
    -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS=OFF \
    -DCMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS=OFF \
    -DLIEF_ELF=off -DLIEF_MACHO=off -DLIEF_OAT=off -DLIEF_DEX=off -DLIEF_VDEX=off -DLIEF_ART=off \
    ${_conf} \
    ..
    #-DBUILD_SHARED_LIBS:BOOL=OFF
    #-DBUILD_STATIC_LIBS:BOOL=OFF

  mkdir -p api/python/lief

  MSYS2_ARG_CONV_EXCL="--include-paths=;--typesystem-paths=" \
  ${MINGW_PREFIX}/bin/cmake.exe --build .
  
  MSYS2_ARG_CONV_EXCL="--include-paths=;--typesystem-paths=" \
  ${MINGW_PREFIX}/bin/cmake.exe --build . --target pyLIEF --config Release
}

package() {
  cd "${srcdir}/LIEF-${pkgver}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake.exe --install build-${MSYSTEM}

  local _PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/pkgconfig/*.pc; do
    sed -s "s|${_PREFIX_WIN}|${MINGW_PREFIX}|g" -i "${_f}"
  done

  # Install egg-info and .pyd
  _pythonpath=`${MINGW_PREFIX}/bin/python -c "import sysconfig; print(sysconfig.get_path('platlib'))"`
  _site_packages=${pkgdir}$(cygpath ${_pythonpath})
  _ext_suffix=`${MINGW_PREFIX}/bin/python -c "import sysconfig; print(sysconfig.get_config_var('EXT_SUFFIX'))"`
  mkdir -p $_site_packages
  cp -r api/python/${_realname}.egg-info $_site_packages/${_realname}-${pkgver}.egg-info
  cp build-${MSYSTEM}/api/python/lief.pyd $_site_packages/lief$_ext_suffix

  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
